<template>
  <div class="time-line">
    <div class="time-group">
      <div class="time-item"
           v-for="bonus in bonuses"
           :class="{'active': bonus.isActive}"
           :style="{width: (100 / (bonuses.length - 1)) + '%'}">
       <div class="content">
          <span class="time__text">{{ getPercent(bonus) }}</span>
          <span class="time__date">{{ formatDate(bonus) }}</span>
         <span class="token__sold" v-if="bonus.timestamp < now || bonus.isActive">{{solds[bonus.timestamp] | formatCurrencyAmount('HETA', '0') }}
           <br v-if="isTablet"> HETA Tokens sold</span>
       </div>
      </div>
    </div>
  </div>
</template>
<script>
import moment from 'moment';
import { mapState } from 'vuex';
import BigNumber from 'bignumber.js';
import MobileDetect from 'mobile-detect';

export default {
  props: {
    solds: {
      type: Object,
    }
  },
  data () {
    return {
      now: moment().valueOf(),
    };
  },
  computed: {
    ...mapState([
      'bonuses',
    ]),
    isTablet() {
      const md = new MobileDetect(window.navigator.userAgent);
      return md.tablet();
    }
  },
  methods: {
    getPercent (bonus) {
      return `${BigNumber(bonus.percent).multipliedBy(100).toString()}%`;
    },
    formatDate (bonus) {
      const time = moment(bonus.timestamp).utcOffset(1);
      if (this.isTablet) {
        return `${time.format('hA')} ${time.format('MM/DD')} GMT +1`;
      }
      return `${time.format('h A')} ${time.format('YYYY/MM/DD')} GMT +1`;
    },
  },
}
</script>
<style lang="scss" scoped>
  @import '../../../../sass/variables';
  @import '../../../../sass/vendor/position';

  .time-line {
    max-width: 1020px;
    min-height: 80px;
    margin: 0 auto;
  }

  .time-group {
    position: relative;

    &:before {
      content: "";
      display: block;
      width: 200vw;
      height: 1px;
      background-color: #2f2f54;
      @include absolute(29px);
      transform: translateX(-50%);
    }
  }
  .time-item {
    position: relative;
    text-align: center;
    display: inline-block;

    .content {
      @include absolute(0, 0);
      transform: translateX(50%);
      min-width: 140px;
    }

    .time__text {
      display: inline-block;
      border-radius: 10px;
      background-color: $dark_blue;
      color: $white;
      font-size: $tiny;
      padding: 5px 10px;
      line-height: 1;
    }

    .time__date {
      display: block;
      color: #707072;
      font-size: $tiny;
      line-height: 2.5;
      font-weight: bold;
      word-spacing: 3px;
      min-width: 160px;
    }

    .token__sold {
      color: #818181;
    }

    &.active {
      position: relative;
      .time__text {
        background-color: $dark_orange;
      }

      .time__date {
        color: $white;
      }

      &:before {
        content: '';
        display: block;
        @include absolute(13px, 0, null, 25px);
        height: 1px;
        background-image: linear-gradient(to left, #da6400, #2f2f54);
      }
    }

    &:nth-child(1) {
      width: 0 !important;
    }
  }
</style>
